From 190c10d323a9726c979ce67593d50e67fd583f57 Mon Sep 17 00:00:00 2001
From: Sergey Radionov <RSATom@gmail.com>
Date: Fri, 2 Dec 2011 22:58:47 +0700
Subject: [PATCH 3/6] common/win32_fullscreen: hook operations moved to
 function

---
 common/win32_fullscreen.cpp |   32 +++++++++++++++++++++-----------
 common/win32_fullscreen.h   |    2 ++
 2 files changed, 23 insertions(+), 11 deletions(-)

diff --git a/common/win32_fullscreen.cpp b/common/win32_fullscreen.cpp
index af3b1b8..78b5dc3 100644
--- a/common/win32_fullscreen.cpp
+++ b/common/win32_fullscreen.cpp
@@ -124,13 +124,7 @@ LRESULT CALLBACK VLCHolderWnd::VLCHolderClassWndProc(HWND hWnd, UINT uMsg, WPARA
             SetWindowLongPtr(hWnd, GWLP_USERDATA, 0);
             break;
         case WM_TRY_SET_MOUSE_HOOK:{
-            HWND hChildWnd = GetWindow(h_data->getHWND(), GW_CHILD);
-            if(!h_data->_hMouseHook && hChildWnd){
-                //Set mouse hook to catch mouse double clicking
-                h_data->_hMouseHook =
-                    SetWindowsHookEx(WH_MOUSE, VLCHolderWnd::MouseHookProc,
-                                     NULL, GetWindowThreadProcessId(hChildWnd, NULL));
-            }
+            h_data->MouseHook(true);
             break;
         }
         case WM_MOUSEMOVE:
@@ -184,6 +178,24 @@ LRESULT CALLBACK VLCHolderWnd::MouseHookProc(int nCode, WPARAM wParam, LPARAM lP
         return 1;
 }
 
+void VLCHolderWnd::MouseHook(bool SetHook)
+{
+    if(SetHook){
+        HWND hChildWnd = GetWindow(getHWND(), GW_CHILD);
+        if(!_hMouseHook && hChildWnd){
+            _hMouseHook =
+                SetWindowsHookEx(WH_MOUSE, VLCHolderWnd::MouseHookProc,
+                                 NULL, GetWindowThreadProcessId(hChildWnd, NULL));
+        }
+    }
+    else{
+        if(_hMouseHook){
+            UnhookWindowsHookEx(_hMouseHook);
+            _hMouseHook = 0;
+        }
+    }
+}
+
 //libvlc events arrives from separate thread
 void VLCHolderWnd::OnLibVlcEvent(const libvlc_event_t* event)
 {
@@ -200,6 +212,7 @@ void VLCHolderWnd::OnLibVlcEvent(const libvlc_event_t* event)
     }
 }
 
+
 void VLCHolderWnd::LibVlcAttach()
 {
     libvlc_media_player_set_hwnd(getMD(), getHWND());
@@ -211,10 +224,7 @@ void VLCHolderWnd::LibVlcDetach()
     if(p_md)
         libvlc_media_player_set_hwnd(p_md, 0);
 
-    if(_hMouseHook){
-        UnhookWindowsHookEx(_hMouseHook);
-        _hMouseHook = 0;
-    }
+    MouseHook(false);
 }
 
 /////////////////////////////////
diff --git a/common/win32_fullscreen.h b/common/win32_fullscreen.h
index 6cd2121..3ca142e 100644
--- a/common/win32_fullscreen.h
+++ b/common/win32_fullscreen.h
@@ -48,7 +48,9 @@ private:
     static LPCTSTR getClassName(void)  { return TEXT("VLC ActiveX Window Holder Class"); };
     static LRESULT CALLBACK VLCHolderClassWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
     static LRESULT CALLBACK MouseHookProc(int nCode, WPARAM wParam, LPARAM lParam);
+
     HHOOK _hMouseHook;
+    void MouseHook(bool SetHook);
 
     libvlc_media_player_t* getMD() const;
 
-- 
1.7.7.1.msysgit.0

